    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.io.InputStreamReader

    java.lang.Object
       |
       +----java.io.Reader
               |
               +----java.io.InputStreamReader

public class InputStreamReader
extends Reader

An InputStreamReader is a bridge from byte streams to character streams: It reads bytes and translates them into characters according to a specified character encoding. The encoding that it uses may be specified by name, or the platform's default encoding may be accepted.

Each invocation of one of an InputStreamReader's read() methods may cause one or more bytes to be read from the underlying byte-input stream. For top efficiency, consider wrapping an InputStreamReader within a BufferedReader; for example,

     BufferedReader in
       = new BufferedReader(new InputStreamReader(System.in));

See Also:
  BufferedReader, InputStream

##

InputStreamReader(InputStream)
  Create an InputStreamReader that uses the default character encoding.
InputStreamReader(InputStream, String)
  Create an InputStreamReader that uses the named character encoding.

##

close()
  Close the stream.
getEncoding()
  Return the name of the encoding being used by this stream.
read()
  Read a single character.
read(char[], int, int)
  Read characters into a portion of an array.
ready()
  Tell whether this stream is ready to be read.

##

InputStreamReader

     public InputStreamReader(InputStream in)

  Create an InputStreamReader that uses the default character encoding.

  Parameters:
    in - An InputStream

InputStreamReader

     public InputStreamReader(InputStream in,
                              String enc) throws UnsupportedEncodingException

  Create an InputStreamReader that uses the named character encoding.

  Parameters:
    in - An InputStream
    enc - Name of encoding to be used
  Throws: UnsupportedEncodingException
    If the named encoding is not supported

##

getEncoding

     public String getEncoding()

  Return the name of the encoding being used by this stream. May return null if the stream has been closed.

read

     public int read() throws IOException

  Read a single character.

  Returns:
    The character read, or -1 if the end of the stream has been reached
  Throws: IOException
    If an I/O error occurs
  Overrides:
    read in class Reader

read

     public int read(char cbuf[],
                     int off,
                     int len) throws IOException

  Read characters into a portion of an array.

  Parameters:
    cbuf - Destination buffer
    off - Offset at which to start storing characters
    len - Maximum number of characters to read
  Returns:
    The number of characters read, or -1 if the end of the stream has been reached
  Throws: IOException
    If an I/O error occurs
  Overrides:
    read in class Reader

ready

     public boolean ready() throws IOException

  Tell whether this stream is ready to be read. An InputStreamReader is ready if its input buffer is not empty, or if bytes are available to be read from the underlying byte stream.

  Throws: IOException
    If an I/O error occurs
  Overrides:
    ready in class Reader

close

     public void close() throws IOException

  Close the stream.

  Throws: IOException
    If an I/O error occurs
  Overrides:
    close in class Reader

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.